// ArkanoidDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Arkanoid.h"
#include "ArkanoidDlg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CArkanoidDlg dialog

CArkanoidDlg::CArkanoidDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CArkanoidDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CArkanoidDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CArkanoidDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CArkanoidDlg)
	DDX_Control(pDX, IDC_SCORE, m_score);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CArkanoidDlg, CDialog)
	//{{AFX_MSG_MAP(CArkanoidDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDOK, OnOk)
	ON_WM_MOUSEMOVE()
	ON_BN_CLICKED(IDSTOP, OnStop)
	ON_WM_LBUTTONDBLCLK()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CArkanoidDlg message handlers

BOOL CArkanoidDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	// Il est important que l'on sache que aucun jeu n'est en cours
	myGame   = NULL;
	myPlayer = NULL;
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CArkanoidDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CArkanoidDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CArkanoidDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

///////////////////////////////////////////////////////////////////////
// Processus surveillant la fin du jeu
///////////////////////////////////////////////////////////////////////
UINT ThreadDlg(LPVOID pParam)
{
   CArkanoidDlg * Cd = (CArkanoidDlg *)(pParam);

   while (!Cd->getMyGame()->getGameEnd()) 
       Sleep(100);

   Cd->GetDlgItem(IDOK)->EnableWindow(TRUE);
   return 0;
}


/* ----------------------------------------------------------------
 * Lors de l'appuie sur Ok, on demmarre le jeu, 
 * si aucun joueur n'existe, on en cr un
 * Un thread est lanc pour surveiller la fin du jeu
 * ----------------------------------------------------------------
 */
void CArkanoidDlg::OnOk() 
{
	// TODO: Add your control notification handler code here
	if (!myPlayer ) {
		myPlayer = new Joueur(GetDlgItem(IDC_SCORE),GetDlgItem(IDC_BALL) );
		myPlayer->updateTxt();
	}
	if ( myGame ) delete myGame;
	myGame = new Game(GetDlgItem(IDC_GAME),myPlayer,mySpeed);

    // Desactive le bouton ok
    GetDlgItem(IDOK)->EnableWindow(FALSE);
	AfxBeginThread(ThreadDlg,this);
}


/* -----------------------------------------------------------------
 * lorsque la souris bouge, la batte doit la suivre, par contre
 * il faut imperativement que un jeu soit en cours
 * -----------------------------------------------------------------
 */
void CArkanoidDlg::OnMouseMove(UINT nFlags, CPoint point) 
{
	if ( myGame ) myGame->moveBatte(point);
	CDialog::OnMouseMove(nFlags, point);
}

/* -----------------------------------------------------------------
 * Lors de l'appuie sur stoppe, on ferme l'application
 * -----------------------------------------------------------------
 */
void CArkanoidDlg::OnStop() 
{
	if (myGame) delete myGame;
    CDialog::OnCancel();
}

/* -----------------------------------------------------------------
 * Demande le lancement d'une balle
 * -----------------------------------------------------------------
 */
void CArkanoidDlg::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	if ( myGame ) myGame->startBall();
	CDialog::OnLButtonDblClk(nFlags, point);
}

/* ----------------------------------------------------------------
 * Le thread de surveillance a besoin d'acceder au jeu
 * ----------------------------------------------------------------
 */
Game * CArkanoidDlg::getMyGame()
{
	return myGame;
}

// Modificateur vitesse du jeu pour pbm pc rapides
void CArkanoidDlg::setSpeed(int v)
{
	mySpeed = v;
}