// Brique.cpp: implementation of the Brique class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Test.h"
#include "Brique.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
Brique::Brique(CRect myRect, Joueur * myPlayer):GameElement(myRect)
{
   GameElement::changeBrush(RGB(200,200,30));
   internalPlayer = myPlayer;
}

Brique::~Brique(){}


//////////////////////////////////////////////////////////////////////
// Fonction de gestion des collisions
//////////////////////////////////////////////////////////////////////
int Brique::doCollision( GameElement * ball, int colStatus )
{
	if ( !visible ) return COL_NONE;

	// La brique est note dtruite
	visible = false;

	int ret = ball->doCollision(this,colStatus);
	if ( ret != COL_NONE )
  	   internalPlayer->donnerPoint(20);
    return ret;
}

//////////////////////////////////////////////////////////////////////
// ACCES A l'etat
//////////////////////////////////////////////////////////////////////
// revoie true si la brique n'est plus visible (detruite)
bool Brique::getStatus()
{
	return ((visible)?false:true);
}