// BriquePoint.h: interface for the BriquePoint class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_BRIQUEPOINT_H__A71CC0EF_7496_4488_9257_07DDF5FD598B__INCLUDED_)
#define AFX_BRIQUEPOINT_H__A71CC0EF_7496_4488_9257_07DDF5FD598B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Brique.h"

/* ====================================================================
 * La brique Point est une brique qui, lorsqu'on la touche se 
 * transforme en un nombre de points tombant. Si la batte touche
 * la brique ainsi transforme les points correspondant sont
 * donnes au joueur, sinon, ils sont perdus
 * ====================================================================
 */
#define STATUS_INIT		0
#define STATUS_TOUCHE   1

class BriquePoint : public Brique  
{
	GameElement * playerBatte;
	int           points;
	int           status;

public:
	BriquePoint(CRect myRect, Joueur * myPlayer, GameElement * batte);
	virtual ~BriquePoint();
    int doCollision( GameElement * ball, int colStatus );
	afficheElement(CDC * theGame);
};

#endif // !defined(AFX_BRIQUEPOINT_H__A71CC0EF_7496_4488_9257_07DDF5FD598B__INCLUDED_)
