// Joueur.h: interface for the Joueur class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_JOUEUR_H__2094D8D5_14DB_4C44_BAEC_41FC41219655__INCLUDED_)
#define AFX_JOUEUR_H__2094D8D5_14DB_4C44_BAEC_41FC41219655__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class Joueur  
{
protected:
	CWnd	   *    scoreWin;		// Objet champ texte du score
	CWnd	   *	balleWin;		// Objet champ texte du nombre de balles
	int				score;			// Score du joueur
	int             balle;			// Nombre de balles restantes pour le joueur

public:
	Joueur(CWnd * _scoreWin, CWnd * _balleWin);
	virtual ~Joueur();
    void donnerPoint(int points);
	void resetScore(void);
    bool haveBall(void);
	void updateTxt(void);
	void addBall(int num);
	int  getScore(void);
};

#endif // !defined(AFX_JOUEUR_H__2094D8D5_14DB_4C44_BAEC_41FC41219655__INCLUDED_)
