// ArkanoidDlg.h : header file
//

#if !defined(AFX_ARKANOIDDLG_H__8F847C37_44A8_4C03_890C_DEE9FE23B9FB__INCLUDED_)
#define AFX_ARKANOIDDLG_H__8F847C37_44A8_4C03_890C_DEE9FE23B9FB__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Game.h"
#include "Joueur.h"
/////////////////////////////////////////////////////////////////////////////
// CArkanoidDlg dialog

class CArkanoidDlg : public CDialog
{
// Construction
public:
	CArkanoidDlg(CWnd* pParent = NULL);	// standard constructor
// Dialog Data
	//{{AFX_DATA(CArkanoidDlg)
	enum { IDD = IDD_ARKANOID_DIALOG };
	CEdit	m_balle;
	CEdit	m_score;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CArkanoidDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
public:    
	Game * getMyGame();
	void   setSpeed(int);	// modificateur vitesse jeu par param

protected:
	HICON    m_hIcon;
	Joueur * myPlayer;
	Game   * myGame;
	int      mySpeed;

	// Generated message map functions
	//{{AFX_MSG(CArkanoidDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnOk();
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnStop();
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ARKANOIDDLG_H__8F847C37_44A8_4C03_890C_DEE9FE23B9FB__INCLUDED_)
