// Batte.h: interface for the Batte class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_BATTE_H__A9F2F9AA_F63C_4718_B746_1A22692A97A8__INCLUDED_)
#define AFX_BATTE_H__A9F2F9AA_F63C_4718_B746_1A22692A97A8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "GameElement.h"
#include "Joueur.h"
#include "Sound.h"



class Batte : public GameElement, public Sound
{
protected:
	int min_x, max_x;	// limites de deplacement de la batte
	Joueur * internalPlayer;

public:
	Batte(CRect myRect, COLORREF myBrush, Joueur * myPlayer);
	virtual ~Batte();
	void setMinMaxX(int minx, int maxx);
    void moveBatte(int deplacement);
    int doCollision(GameElement *ball, int colStatus);
};

#endif // !defined(AFX_BATTE_H__A9F2F9AA_F63C_4718_B746_1A22692A97A8__INCLUDED_)
