// BriqueDure.cpp: implementation of the BriqueDure class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Arkanoid.h"
#include "BriqueDure.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

BriqueDure::BriqueDure(CRect myRect, Joueur * myPlayer):Brique(myRect,myPlayer)
{
	GameElement::changeBrush(RGB(0,0,120));
	touche = 0;
}

BriqueDure::~BriqueDure()
{

}


//////////////////////////////////////////////////////////////////////
// Fonction de gestion des collisions
//////////////////////////////////////////////////////////////////////
int BriqueDure::doCollision( GameElement * ball, int colStatus )
{
	int ret;
	ret = Brique::doCollision(ball,colStatus); 
	if ( ret != COL_NONE ) {
       // Finalement la brique n'est dtruite que si elle est touche deux fois
	   if (++touche < 2) {
			visible = true;
            GameElement::changeBrush(RGB(0,0,255));
	   }
	}
    return ret;
}
