// Tableau.cpp: implementation of the Tableau class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Arkanoid.h"
#include "Tableau.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Tableau::Tableau(CRect myRect, COLORREF myBrush):GameElement(myRect,myBrush)
{

}

Tableau::~Tableau()
{

}

//////////////////////////////////////////////////////////////////////
// Fonction de gestion des collisions
//////////////////////////////////////////////////////////////////////
int Tableau::doCollision( GameElement * ball, int colStatus )
{
	if ( colStatus == COL_BOTTOM ) {
	   // La balle est perdue
		return COL_LOST;
	} else {
       // la balle rebondit
       return ball->doCollision(this,colStatus);
	}
}
